summaryrefslogtreecommitdiffstats
path: root/icecast
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2010-09-15 15:09:28 +0000
committer Eric Hameleers <alien@slackware.com>2010-09-15 15:09:28 +0000
commit8e54cdb0ce0d12db3d8e218535d3347877d22046 (patch)
treeeeb8d8550967ad15b11fbd7051f87709328448d5 /icecast
parent5e4617c8927936c8ba04c8e7b2d80ead06b33bb7 (diff)
downloadasb-8e54cdb0ce0d12db3d8e218535d3347877d22046.tar.gz
asb-8e54cdb0ce0d12db3d8e218535d3347877d22046.tar.xz
Update to 2.3.2 and cleanups for Slackware 13.1
Diffstat (limited to 'icecast')
-rwxr-xr-xicecast/build/icecast.SlackBuild421
1 files changed, 242 insertions, 179 deletions
diff --git a/icecast/build/icecast.SlackBuild b/icecast/build/icecast.SlackBuild
index da59d16f..b1dc557f 100755
--- a/icecast/build/icecast.SlackBuild
+++ b/icecast/build/icecast.SlackBuild
@@ -1,163 +1,224 @@
#!/bin/sh
# $Id$
-# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
-# Distributed under the terms of the GNU General Public License, Version 2
-# ---------------------------------------------------------------------------
-# Slackware SlackBuild script
-# ===========================
-# By: Eric Hameleers <alien@slackware.com>
-# For: Icecast
-# URL: http://www.icecast.org/
-# Summary: Xiph Streaming media server that supports
-# multiple audio formats (and theora video streams too).
-# Needs: libvorbis, libogg, libxml2, curl
-# Changelog:
-# 2.0.0-1: 16/jan/2004 by Eric Hameleers
-# 2.0.0-2: 17/jan/2004 by Eric Hameleers
-# Bug fix in the rc.icecast script
-# 2.0.0-3: 22/apr/2004 by Eric Hameleers
-# Add "next" operatrion to rc.icecast
-# 2.0.2-1: 20/oct/2004 by Eric Hameleers
-# Rebuilt new releease.
-# 2.2.0-1: 01/jan/2005 by Eric Hameleers
-# Rebuilt new releease.
-# 2.2.0-2: 11/aug/2005 by Eric Hameleers
-# Add "current" and "status" to rc.icecast parameters.
-# Make sure that existing /etc/rc.d/rc.icecast isn't overwritten.
-# 2.2.0-3: 17/sep/2005 by Eric Hameleers
-# Forgot to add "current" to rc.icecast 'help' output
-# (i.e. run rc.icecast with no parameters).
-# 2.3.0-1: 04/oct/2005 by Eric Hameleers
-# New release.
-# 2.3.1-1: 28/feb/2006 by Eric Hameleers <alien@sox.homeip.net>
-# New release.
+# Copyright 2004,2005,2006,2010 Eric Hameleers <alien@slackware.com>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
#
-# ---------------------------------------------------------------------------
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: icecast
+# Descr: Xiph's streaming media server for mp3 and ogg audio
+# URL: http://icecast.org/
+# Needs:
+# Changelog:
+# 2.0.0-1: 16/jan/2004 by Eric Hameleers
+# 2.0.0-2: 17/jan/2004 by Eric Hameleers
+# Bug fix in the rc.icecast script
+# 2.0.0-3: 22/apr/2004 by Eric Hameleers
+# Add "next" operatrion to rc.icecast
+# 2.0.2-1: 20/oct/2004 by Eric Hameleers
+# Rebuilt new releease.
+# 2.2.0-1: 01/jan/2005 by Eric Hameleers
+# Rebuilt new releease.
+# 2.2.0-2: 11/aug/2005 by Eric Hameleers
+# Add "current" and "status" to rc.icecast parameters.
+# Make sure that existing /etc/rc.d/rc.icecast isn't overwritten.
+# 2.2.0-3: 17/sep/2005 by Eric Hameleers
+# Forgot to add "current" to rc.icecast 'help' output
+# (i.e. run rc.icecast with no parameters).
+# 2.3.0-1: 04/oct/2005 by Eric Hameleers
+# New release.
+# 2.3.1-1: 28/feb/2006 by Eric Hameleers <alien@sox.homeip.net>
+# New release.
+# 2.3.2-1: 15/Sep/2010 by Eric Hameleers <alien@slackware.com>
+# * New release and build for Slackware 13.1.
+#
+# Run 'sh icecast.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
#
+# -----------------------------------------------------------------------------
+
# Set initial variables:
-CWD=`pwd`
-if [ "$TMP" = "" ]; then
- TMP=/tmp
-fi
PRGNAM=icecast
-VERSION=2.3.1
-ARCH=i486
-BUILD=1
+VERSION=${VERSION:-2.3.2}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
-PKG=$TMP/package-$PRGNAM
+# This covers most filenames you'd want as documentation. Change if needed.
+DOCS="ABOUT* AUTHORS BUGS ChangeLog* COPYING CREDITS FAQ GPL* HACKING \
+ LICENSE MAINTAINERS NEWS README* TODO"
-if [ ! -d $TMP/tmp-$PRGNAM ]; then
- mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-fi
-if [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
-fi
+# The deamon process uses its own userid:
+iceuser=icecast
+icegroup=icecast
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
-# --- HELPER FUNCTIONS ---
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+SRCURL="http://downloads.xiph.org/releases/${PRGNAM}/${PRGNAM}-${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
-#
-# Function 'preconfig filename [remove]'
-#
-# param1 (required) may be a wildcard;
-# in that case surround it with double quotes!
-# param2 (optional) has value 'remove'
-#
-# Description:
-# Prepare the incoming configuration files which are not allowed
-# to overwrite existing ones.
-# These files will get a '.new' extension.
-# An entry in the 'doinst.sh' script will be created for these files, copying
-# the *.new files back to their original names,
-# but only if the original names don't exist.
-# Use the second parameter 'remove', like in 'preconfig filename(s) remove'
-# to add a 'rm -f filename.new' in 'doinst.sh', so as not to clutter
-# the harddisk with useless example files.
-
-preconfig() {
- mkdir -p $PKG/install 2>/dev/null
- for infile in $1; do
- mv ${infile} ${infile}.new
- done
- echo -n "config \"$1.new\"" >> $PKG/install/doinst.sh
- # If there's a second parameter with value 'remove' add a 'rm filename.new'
- if [ "$2" = "remove" ]; then
- echo -n " ; rm -f $1.new" >> $PKG/install/doinst.sh
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ *) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
fi
- echo "" >> $PKG/install/doinst.sh
-}
+fi
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
# --- PACKAGE BUILDING ---
-echo "+==============+"
-echo "| $PRGNAM-$VERSION |"
-echo "+==============+"
-
-iceuser=icecast
-icegroup=icecast
-
-rm -rf $PKG/*
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
# Explode the package framework:
-cd $PKG
-if [ -f $CWD/_$PRGNAM.tar.gz ]; then
- explodepkg $CWD/_$PRGNAM.tar.gz
+if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
+ cd $PKG
+ explodepkg $SRCDIR/_$PRGNAM.tar.gz
+ cd -
fi
cd $TMP/tmp-$PRGNAM
-
-# Extract tar ball in TEMP dir
-echo Building $PRGNAM...
-tar -zxvf $CWD/$PRGNAM-$VERSION.tar.gz
-cd $PRGNAM-$VERSION
-./configure --prefix=/usr --sysconfdir=/usr/share/icecast/etc \
- --localstatedir=/var \
- 2>&1 | tee $CWD/configure-${PRGNAM}.log
-
-make 2>&1 | tee $CWD/make-${PRGNAM}.log
-
-# Install all the needed stuff to the package dir
-# Use installwatch if available:
-which installwatch > /dev/null 2>&1
-if [ $? == 0 ]; then
- installwatch -o $CWD/install-${PRGNAM}.log make DESTDIR=$PKG install
-else
- make DESTDIR=$PKG install 2>&1 |tee $CWD/install-${PRGNAM}.log
-fi
-
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+X-s .
+
+echo Building ...
+LDFLAGS="$SLKLDFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --localstatedir=/var \
+ --sysconfdir=/etc/icecast \
+ --program-prefix= \
+ --program-suffix= \
+ --build=$ARCH-slackware-linux \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Create an icecast log directory:
mkdir -p $PKG/var/log/icecast
-(cd $PKG/usr/share/icecast/etc && patch -p0 < $CWD/icecast_conf.patch)
-
-# --- DOCUMENTATION ---
-
-# Compress the man page
-gzip -9 $PKG/usr/man/*/*
-
-# Copy the documentation
-mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-mv $PKG/usr/share/doc/icecast/* $PKG/usr/doc/$PRGNAM-$VERSION/
-rm -r $PKG/usr/share/doc
-chmod -R -w $PKG/usr/doc/$PRGNAM-$VERSION
+# Don't use nobody - we create an icecast account:
+( cd $PKG/etc/icecast && patch -p0 --verbose < $SRCDIR/icecast_conf.patch )
+# Ensure we do not overwrite any customizations:
+mv $PKG/etc/icecast/icecast.xml{,.new}
-# --- POST-INSTALL SCRIPT ---
+# Add a rc script:
+mkdir -p $PKG/etc/rc.d
+cat $SRCDIR/rc.icecast.new > $PKG/etc/rc.d/rc.icecast.new
-# --- Fabricate the 'doinst.sh' script: ------
-mkdir -p $PKG/install
-
-cat <<EOINS > $PKG/install/doinst.sh
+# Add this to the doinst.sh:
+! [ -d $PKG/install ] && mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
# Handle the incoming configuration files:
config() {
for infile in \$1; do
NEW="\$infile"
- OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
+ OLD="\$(dirname \$NEW\)/\$(basename \$NEW .new\)"
# If there's no config file by that name, mv it over:
if [ ! -r \$OLD ]; then
mv \$NEW \$OLD
- elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
+ elif [ "\$(cat \$OLD | md5sum\)" = "\$(cat \$NEW | md5sum\)" ]; then
# toss the redundant copy
rm \$NEW
fi
@@ -165,22 +226,34 @@ config() {
done
}
-# Take care of rc.icecast
-config etc/rc.d/rc.icecast.new
+preserve_perms() {
+ NEW="\$1"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ if [ -e \$OLD ]; then
+ cp -a \$OLD \${NEW}.incoming
+ cat \$NEW > \${NEW}.incoming
+ mv \${NEW}.incoming \$NEW
+ fi
+ config \$NEW
+}
+
+config etc/icecast/icecast.xml.new
+preserve_perms etc/rc.d/rc.icecast.new
-#Add the '${icegroup}' group if it doesn't exist already
-groupadd ${icegroup} 2> /dev/null
-#Add the '${iceuser}' user if it doesn't exist already
-useradd -c "Icecast" -d /usr/share/icecast \\
- -g ${icegroup} -s "/bin/false" ${iceuser} 2> /dev/null
+# Only way to create and use the correct uid and gid on the target system,
+# is to use chroot:
+# Add the '${icegroup}' group if it doesn't exist already.
+chroot . <<EOR 2>/dev/null
+/usr/sbin/groupadd ${icegroup} 2> /dev/null
+# Add the '${iceuser}' user if it doesn't exist already
+/usr/sbin/useradd -c "Icecast" -d /usr/share/icecast \\
+ -g ${icegroup} -s "/bin/false" ${iceuser} 2> /dev/null
# Configure the home directory
-mkdir -p usr/share/icecast
chown -R ${iceuser}:${icegroup} usr/share/icecast
chmod 750 usr/share/icecast
# Configure the log directory
-mkdir -p var/log/icecast
chown -R ${iceuser} var/log/icecast
chmod 750 var/log/icecast
@@ -188,57 +261,47 @@ chmod 750 var/log/icecast
# Update rc.local so that Icecast will be started on boot
#
if ! grep "rc.icecast" etc/rc.d/rc.local 1>/dev/null 2>&1 ; then
- cat <<-_EOM_ >> etc/rc.d/rc.local
-
- if [ -x /etc/rc.d/rc.icecast ]; then
- # Start Icecast server
- echo "Starting icecast: /etc/rc.d/rc.icecast start"
- /etc/rc.d/rc.icecast start
- fi
- _EOM_
+ cat <<_EOM_ >> etc/rc.d/rc.local
+
+if [ -x /etc/rc.d/rc.icecast ]; then
+ # Start Icecast server
+ echo "Starting icecast: /etc/rc.d/rc.icecast start"
+ /etc/rc.d/rc.icecast start
+fi
+_EOM_
fi
EOINS
-# --- End of 'doinst.sh' script -----------
-
-# Finally, take care of the configuration files:
-# Rename those files which must not overwrite existing ones when the package
-# is installed. Corresponding entries will be created at the end of
-# the 'doinst.sh' script.
-(cd $PKG ; preconfig usr/share/icecast/etc/$PRGNAM.xml)
-echo "" >> $PKG/install/doinst.sh
-
-
-# --- OWNERSHIP, RIGHTS ---
-chown -R root.root $PKG
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+#cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
-find $PKG -type f -name "*~" -exec rm -f {} \;
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
-# --- PACKAGE DESCRIPTION ---
+# Add a package description:
mkdir -p $PKG/install
-cat $CWD/icecast.slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/${PRGNAM}.slack-desc > $PKG/install/slack-desc
-
-# --- BUILDING ---
-
-# Build the package and compute its md5 checksum:
+# Build the package:
cd $PKG
-makepkg --linkadd y --chown n $TMP/$PRGNAM-$VERSION-$ARCH-$BUILD.tgz
-(cd $TMP && md5sum $PRGNAM-$VERSION-$ARCH-$BUILD.tgz > $PRGNAM-$VERSION-$ARCH-$BUILD.tgz.md5)
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/$PRGNAM-$VERSION-$ARCH-$BUILD.txt
-
-
-# --- CLEANUP ---
-
-# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
- rm -rf $TMP/tmp-$PRGNAM
- rm -rf $PKG
-else
- echo You can check the 'installwatch' log file: $CWD/install-${PRGNAM}.log
-fi
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+
+# Restore the original umask:
+umask ${_UMASK_}
-#
-# EOF
-#